header {
	package compilateur;
import java.util.Vector ;
import compilateur.cspLangage.*;
}
class P extends Parser;
options {
	k = 2;
}

programme returns [Programme prog] 
			{ prog = new Programme (); Macro m; Define d=null; } :   
		(d=declarationConstante { prog.defines.add(d); })*
				(
		m		=declarationListeCommande {prog.macros.add (m); }
		)		+
		EOF 
	    ;
		
declarationConstante returns [Define def = new Define ()]
	{Identifier id; Valeur v; } :
	DEFINE id=identifier v=valeur { def.id = id; def.valeur = v; }
	;
	
string returns [StringValeur str=new StringValeur()]: 
	t:STRING_LITERAL { str.token = t; }
	;
	
valeur returns [Valeur v=null] :
	v=nombre
	|		
	v=string
|
	TRUE { v= new True (); }
	| 
	FALSE { v= new False (); }
	;

valeurTab [Commande parent] returns [ValeurTab vt=new ValeurTab(parent)]
{Variable v = null; ExpressionSimple e = null; } :
v=variable[parent] { vt.variable = v; }
CROCHETG
e=expressionSimple[parent] { vt.indices.add (e); }
	(VIRGULE e=expressionSimple[parent] {vt.indices.add(e); })*
CROCHETD
	;


identifier returns [Identifier id=new Identifier()] :
	t:IDENTIFIER { id.token = t; }
	;
	
idListeCommande returns [Identifier id=null] :
	id=identifier
	;

variable [Commande parent] returns [Variable v=new Variable(parent)] 
	{Identifier id; }:
	id = identifier { v.id = id; }
	;

typeBase [Commande parent] returns [SimpleType type=null] :
	t1:INTEGER { type = new SimpleType (t1, parent); }
	|
	t2:STRING { type = new SimpleType (t2, parent); }
	|
	t3:BOOLEAN { type = new SimpleType (t3, parent); }
	;
	
typeTab [Commande parent] returns [ArrayType tab = new ArrayType(parent)] 
	{SimpleType st = null; Range r = null; } :
	(
		CROCHETG 
		r=simpleRange[parent] { tab.ranges.add (r); }
		(VIRGULE r=simpleRange[parent]  {tab.ranges.add(r); })* 
		CROCHETD
		st=typeBase [parent]{ tab.type = st; }
	)
	;
		
type [Commande parent] returns [Type type=null] 
{TypeStructuree t = null; }:
	type=typeBase[parent]
	|
	type = typeStructuree[parent]
	|
	type = typeTab[parent]
	;

typeStructuree [Commande parent] returns [TypeStructuree ts=new TypeStructuree()] 
	{ Identifier id; Type t; } :
id=constructeur { ts.constructeur = id; }
PARG
(t=type [parent]{ ts.types.add (t); }
(VIRGULE t=type[parent] { ts.types.add(t); })*
)?
PARD
|
PARG
(t=type [parent]{ ts.types.add (t); }
(VIRGULE t=type [parent] { ts.types.add(t); })*
)?
PARD
;

nomProcessus returns [Identifier id=null] :
	id=identifier
	;

nombre returns [Nombre nb=new Nombre()] :
	t2:ENTIER { nb.token = t2; }
	;

declarationListeCommande returns [Macro m] 
	{Identifier t; ListeCommande liste; m = new Macro(); } :
		t=idListeCommande 
		DOUBLE_EGAL
		liste=listeCommande[null, m]	{m.id = t; m.setListe(liste);}
		;

listeCommande [ListeCommande parent, Macro mParent] returns [ListeCommande liste]
	{Commande c; if (mParent != null) liste = new ListeCommande(mParent); else liste = new ListeCommande(parent);} :
		c=commande[liste] { liste.add (c); }
		(PT_VIRGULE c=commande[liste] {liste.add (c); })*
		;
	
commande [ListeCommande parent] returns [Commande cmd=null]
	{ Token first = null; } :
	{first = LT(1); }
	(cmd=commandeSimple[parent]
	|
	cmd=commandeStructuree[parent]
	)
	{ cmd.firstToken = first; cmd.lastToken = LT(0); }
	;

commandeSimple [ListeCommande parent] returns [Commande cmd=null]:
	cmd=commandeNulle[parent]
	|
	cmd=declaration[parent]
	|
	cmd=commandePrint[parent]
	|
	cmd=commandeSleep[parent]
	|
	(commandeAffectation[parent]) => cmd=commandeAffectation[parent]
	|
	cmd=commandeES[parent]
	;

commandeSleep [ListeCommande parent] returns [CommandeSleep cmd = new CommandeSleep (parent)]
{ExpressionSimple v = null ;} :
SLEEP
PARG
v=expressionSimple[cmd] { cmd.expr = v; }
PARD
;

commandePrint [ListeCommande parent] returns [CommandePrint cmd = new CommandePrint (parent)]
{ExpressionSimple v = null ;} :
PRINT
PARG
v=expressionSimple[cmd] { cmd.expr = v; }
PARD
;

commandeNulle [ListeCommande parent] returns [Commande cmd=null]:
	SKIP { cmd = new CommandeNulle (parent); }
	;

declaration [ListeCommande parent] returns [Declaration cmd=new Declaration(parent)]
	{Vector<Variable> liste; Type t=null; Expression e; } :
	liste=listeVariable [cmd]
	DEUX_PTS
	t=type[cmd]
	{cmd.variables = liste; cmd.type=t;}
	(
		AFFECT
		e=expression[cmd] { cmd.valeur = e; }
	)?		
		;
	
	listeVariable [Commande parent] returns [Vector<Variable> liste = new Vector<Variable>()]
	{Variable v; }:
		v=variable[parent] {liste.add (v);}
		(VIRGULE v=variable[parent] {liste.add(v);})*
		;
	
commandeAffectation [ListeCommande parent] returns [Affectation cmd]
	{VariableCible cible; Expression source; cmd = new Affectation(parent); }:
		cible=variableCible[cmd] AFFECT source=expression [cmd]
		{cmd.cible = cible; cmd.source=source;}
		;
	
variableCible [Commande parent] returns [VariableCible vc=null] :
		(cibleArray[parent])=> vc=cibleArray[parent]
		|
		(cibleStructuree[parent])=>vc=cibleStructuree[parent]
		|
		vc=variableCibleSimple[parent]
		;

cibleArray [Commande parent] returns [CibleArray cible = new CibleArray(parent)] 
	{ Variable v=null; ExpressionSimple e=null;}:
	v=variable [parent]
	CROCHETG
	e=expressionSimple[parent] { cible.indices.add (e); }
	(VIRGULE e=expressionSimple[parent] {cible.indices.add(e); })*
	CROCHETD
	{ cible.variable = v; }
	;	

variableCibleSimple [Commande parent] returns [VariableCibleSimple vc=new VariableCibleSimple(parent)]
	{Variable v = null ; } :
	v = variable[parent] { vc.variable = v; }
	;	

cibleStructuree [Commande parent] returns [CibleStructuree cs=new CibleStructuree(parent)] 
	{Identifier cons; Vector<VariableCible> liste; }:
	cons=constructeur  {cs.constructeur = cons; }
	PARG 
		(
		liste=listeVariableCible[parent] {cs.liste = liste; }
		)?
	PARD
	|
	(
		PARG 
		liste=listeVariableCible [parent] {cs.liste = liste; } 
		PARD
	)
	;

constructeur returns [Identifier id=null] :
	id=identifier
	;

listeVariableCible [Commande parent] returns [Vector<VariableCible> liste]
	{liste = new Vector<VariableCible> (); VariableCible v; }:
		v=variableCible[parent] {liste.add (v); }
		(
		VIRGULE 
		v=variableCible[parent] {liste.add (v); }
		)*
		;

expression [Commande parent] returns [Expression v=null] :
	(expressionStructuree[parent]) => v=expressionStructuree[parent]
|
v=expressionTab[parent]
|
	v=expressionSimple[parent]
	;

expressionTab [Commande parent] returns [ExpressionTab e=new ExpressionTab(parent)]
	{ExpressionSimple expr = null; Range r=null; } :
	CROCHETG
	r=simpleRange[parent] { e.ranges.add (r); }
	(VIRGULE r=simpleRange[parent] {e.ranges.add(r); })* 
	CROCHETD
	expr=expressionSimple[parent] { e.expression = expr; }
	;

expressionStructuree [Commande parent] returns [ExpressionStructuree e]
	{ e = new ExpressionStructuree (parent); Identifier t; Vector<Expression> liste; }:	
		(
		t=constructeur {e.constructeur = t; }
		PARG 
		(liste=listeExpression [parent] {e.expressions = liste; })? 
		PARD
		)
		;

listeExpression [Commande parent] returns [Vector<Expression> liste=new Vector<Expression>()]
	{ Expression e; } :
	e=expression[parent] { liste.add (e); }
	(VIRGULE e=expression[parent] {liste.add (e); })*
	;

commandeES [ListeCommande parent] returns [CommandeES cmd=null] 
{Token first = LT(1); } :
(
(commandeSortie[parent]) => cmd=commandeSortie[parent]
|
cmd=commandeEntree[parent]
)
{ cmd.firstToken = first; cmd.lastToken = LT(1); }
;

commandeSortie [ListeCommande parent] returns [CommandeOutput cmd=new CommandeOutput(parent)] 
{ProcessusCible p; Expression e; } :
p=processusCible [cmd]
OUTPUT
e=expression[cmd] { cmd.expression = e; cmd.processusCible = p; }
;

commandeEntree [ListeCommande parent] returns [CommandeInput cmd=new CommandeInput(parent)] 
{ProcessusCible p; VariableCible vc; } :
p=processusCible [cmd]
INPUT
vc=variableCible[cmd] { cmd.variableCible = vc; cmd.processusCible = p; }
;

processusCible [Commande parent] returns [ProcessusCible p = new ProcessusCible (parent)]
	{ Identifier nom; Vector<ExpressionSimple> liste; }:
	nom=nomProcessus { p.nomProcessus = nom; }
	(
	CROCHETG liste=listeIndice[parent] CROCHETD { p.listeIndice = liste; }
	)?
	;
	
listeIndice [Commande parent] returns [Vector<ExpressionSimple> liste]
	{ liste = new Vector<ExpressionSimple> (); ExpressionSimple e;}:
	e=expressionSimple [parent] { liste.add (e); }
	(VIRGULE e=expressionSimple [parent] {liste.add(e); })*
	;
	
commandeStructuree [ListeCommande parent] returns [Commande cmd=null]:
	(commandeParallele[parent]) => cmd=commandeParallele[parent]
	|
	cmd=commandeAlternative[parent]
	|
	cmd=commandeRepetitive[parent]
	;
	
commandeParallele [ListeCommande parent] returns [CommandeParallele cmd]
	{cmd = new CommandeParallele (parent); Vector<Processus> liste;}:
	CROCHETG liste=listeProcessus [cmd] CROCHETD { cmd.listeProcessus = liste; }
	;

listeProcessus [Commande cmd] returns [Vector<Processus> liste]
	{ liste = new Vector<Processus> (); Processus p; }:
	p=processus[cmd] {liste.add (p); }
	(PARALLELE p=processus [cmd] {liste.add (p); })*
	;

processus [Commande parent] returns [Processus p]
	{p = new Processus (parent); LabelProcessus label; ListeCommande liste; 
	Identifier id; } :
	label=labelProcessus [parent] DOUBLE_DEUX_PTS { p.label = label; }
	(
	(listeCommande[parent.parent, null]) => liste=listeCommande [parent.parent, null] { p.listeCommande = liste; }
	| 
	id=idListeCommande { p.idListeCommande = id; }
	)
	;
	
labelProcessus [Commande cmd] returns [LabelProcessus label=new LabelProcessus(cmd)]
	{Identifier nom; Vector<IndiceLabel> liste; }:
	nom=nomProcessus { label.nomProcessus = nom; }
	(
	CROCHETG liste=listeIndiceLabel[cmd] { label.listeIndice = liste; } CROCHETD
	)?
	;

listeIndiceLabel [Commande parent] returns [Vector<IndiceLabel> liste ]
	{liste = new Vector<IndiceLabel> (); IndiceLabel i; }:
	i=indiceLabel [parent] {liste.add (i); }
	(VIRGULE i=indiceLabel [parent] {liste.add(i); })*
	;

indiceLabel [Commande cmd] returns [IndiceLabel indice = new IndiceLabel()]
	{ExpressionSimple expr; Range r; }:
/*	expr=expressionSimple [cmd] {indice.expr = expr; } -> ON EVITE AINSI UN PROB AVEC proc[1] :: ...s
	|*/
	r=range [cmd] {indice.range = r;}
	;

simpleRange [Commande cmd] returns [Range r = new Range(cmd)]
{ ExpressionSimple e; }:
e=expressionSimple [cmd] { r.borneInf = e; }
DOUBLE_PT
e=expressionSimple [cmd] { r.borneSup = e; }
;

range [Commande cmd] returns [Range r = new Range (cmd)]
	{Variable v; ExpressionSimple e; }:
	v=variable[cmd] {r.variable = v; }
	DEUX_PTS 
	e=expressionSimple [cmd] {r.borneInf = e; }
	DOUBLE_PT 
	e=expressionSimple [cmd] {r.borneSup = e; }
	;
	
commandeRepetitive [ListeCommande parent] returns [CommandeAlternative cmd=null] :
	ETOILE 
	cmd=commandeAlternative[parent]
	{cmd.type = CommandeAlternative.REPETITIVE; }
	;

commandeAlternative [ListeCommande parent] returns [CommandeAlternative cmd=new CommandeAlternative(parent)]
	{Vector<CommandeGardee> liste; } :
	CROCHETG 
	liste=listeCommandeGardee [cmd] { cmd.liste = liste; }
	CROCHETD
	;

listeCommandeGardee [Commande parent] returns [Vector<CommandeGardee> liste ]
	{liste = new Vector<CommandeGardee> (); CommandeGardee c; }:
	c=commandeGardee[parent] { liste.add (c); }
	(
	CROCHETG CROCHETD 
	c=commandeGardee [parent] { liste.add (c); }
	)*
	;

commandeGardee [Commande parent] returns [CommandeGardee c]
	{c = new CommandeGardee(parent); Range r; c.listeRange = new Vector<Range> (); 
	Garde g; ListeCommande liste; }:
	(
	(PARG range[c] (VIRGULE range[c])* PARD) 
		=>
		PARG 
		r=range[c] { c.listeRange.add (r); }
		(VIRGULE r=range[c] {c.listeRange.add(r);})* 
		PARD
	)?
	g=garde [c] FLECHE liste=listeCommande [parent.parent, null] {c.garde = g; c.setListeCommande (liste); }
	;
	
garde [Commande parent] returns [Garde g]
	{g = new Garde (parent); Vector<Declaration> liste; CommandeES cmd; ExpressionSimple e;}:
(expressionSimple[parent] PT_VIRGULE commandeES[parent.parent])
=>
	e = expressionSimple[parent]  { g.exprBool = e; }
	PT_VIRGULE 
	cmd=commandeES [parent.parent] { g.commandeES = cmd; }
|
(commandeES[parent.parent]) => cmd=commandeES [parent.parent] { g.commandeES = cmd; }
|
e=expressionSimple [parent] { g.exprBool = e; }
;

listeDeclaration [Commande parent] returns [Vector<Declaration> liste]
	{liste = new Vector<Declaration> (); Declaration d;}:
	d=declaration [parent.parent] {liste.add (d); }
	(
		(PT_VIRGULE declaration[parent.parent])
		=>
			PT_VIRGULE 
			d=declaration [parent.parent] { liste.add (d); } 
	)*
	;
	
expressionSimple [Commande parent] returns [ExpressionSimple mem=null] 
	{ ExpressionSimple e, nouv; Token t=null; Token first = LT(1); }:
	mem=exprBool [parent]
	(
		(
		t1:AND  {t = t1; }
		| 
		t2:OR {t = t2; }
		) 
		e=exprBool [parent]{ nouv = new ExpressionSimple (parent); 
					 nouv.leftMember = mem; 
					 nouv.operateur = t;
					 nouv.rightMember = e;
					 mem = nouv;
				   }
	)*
	{ mem.first = first; mem.last = LT(1); }
	;

exprBool [Commande parent] returns [ExpressionSimple mem=null] 
	{ ExpressionSimple e,nouv; Token t = null;}:
	mem=expressionOp[parent]
	(
		(
		t1:EGAL  {t = t1; }
		| 
		t2:SLASH_EGAL { t = t2; }
		|
		t3:PLUSGRAND_EGAL { t = t3; }
		|
		t4:PLUSPETIT_EGAL { t = t4; }
		|
		t5:PLUSGRAND { t = t5; }
		|
		t6:PLUSPETIT { t = t6; }
		) 
		e=expressionOp[parent] { nouv = new ExpressionSimple (parent); 
					 nouv.leftMember = mem; 
					 nouv.operateur = t;
					 nouv.rightMember = e;
					 mem = nouv;
				   }
	)*
	;

expressionOp [Commande parent] returns [ExpressionSimple mem=null] 
	{ ExpressionSimple e, nouv; Token t=null; }:
	mem=expr [parent]
	(
		(
		t1:PLUS  {t = t1; }
		| 
		t2:MOINS {t = t2; }
		) 
		e=expr [parent] { nouv = new ExpressionSimple (parent); 
				 nouv.leftMember = mem; 
				 nouv.operateur = t;
				 nouv.rightMember = e;
				 mem = nouv;
			   }
	)*
	;

expr [Commande parent] returns [ExpressionSimple mem=null] 
	{ ExpressionSimple e,nouv; Token t = null;}:
	mem=atom[parent]
	(
		(
		t1:ETOILE { t = t1; }
		| 
		t2:DIV { t = t2; }
		| 
		t3:MOD { t = t3; }
		) 
		e=atom [parent] { nouv = new ExpressionSimple (parent); 
				 nouv.leftMember = mem; 
				 nouv.operateur = t;
				 nouv.rightMember = e;
				 mem = nouv;
			   }
	)*
	;

atom [Commande parent] returns [ExpressionSimple mem=null] 
	{ Valeur n; Variable v; } :
(valeurTab [parent]) => mem=valeurTab [parent]
	|
	mem=valeur
	|
mem=variable [parent]
		|
mem=fonctionRandom [parent]
			|
	PARG mem=expressionSimple [parent] PARD
	;

fonctionRandom [Commande parent] returns [FonctionRandom rand = new FonctionRandom(parent)]
{ExpressionSimple min = null; ExpressionSimple max = null; } :
RANDOM
PARG
min = expressionSimple [parent] { rand.min = min; }
VIRGULE
max = expressionSimple [parent] { rand.max = max; }
PARD
;
////////////////////////////
// LEXER
////////////////////////////
class L extends Lexer;
options {
	k = 2;
}

tokens {
	USE = "use";
	SKIP = "skip";
	TRUE = "true";
	FALSE = "false";
	MOD = "mod";
	DEFINE = "define";
	INTEGER = "integer";
	BOOLEAN = "boolean";
	STRING = "string";
	PRINT = "print";
	SLEEP = "sleep";
	RANDOM = "random";
	}

SLASH_EGAL : "/=";
PLUS : '+';
MOINS: '-';
DIV : '/';
PLUSGRAND : '>';
PLUSPETIT : '<';
PLUSGRAND_EGAL : ">=";
PLUSPETIT_EGAL : "<=";
FLECHE : "->";
VIRGULE : ',';
AFFECT : ":=";
DOUBLE_PT : "..";
DOUBLE_DEUX_PTS : "::";
DEUX_PTS : ':';
PARG : '(';
PARD : ')';
CROCHETG : '[';
CROCHETD : ']';
ENTIER : ('0'..'9')+;
DOUBLE_EGAL : "==";
EGAL : "=";
PARALLELE : "||";
OR : '|';
AND : '&';
PT_VIRGULE : ';';
INPUT : '?';
OUTPUT : '!';
ETOILE : '*';

IDENTIFIER
	options {testLiterals=true;} :
	( 'a'..'z'|'A'..'Z') ( 'a'..'z'|'A'..'Z'|'_'|'0'..'9')*
    ;

// multiple-line comments
ML_COMMENT
	:	"/*"
		(	
			options {
				generateAmbigWarnings=false;
			}
		:
			{ LA(2)!='/' }? '*'
		|	'\r' '\n'		{newline();}
		|	'\r'			{newline();}
		|	'\n'			{newline();}
		|	~('*'|'\n'|'\r')
		)*
		"*/"
		{$setType(Token.SKIP);}
	;

WHITESPACE :
	( ' '
	| '\t'
	| '\f'
	)
	{ $setType(antlr.Token.SKIP); }
	;

NEWLINE:   
    (	"\r\n"   
    |   '\r'
    |   '\n')
    { $setType(antlr.Token.SKIP); newline();}
    ;




STRING_LITERAL
	:	'"' (ESC|~('"'|'\\'|'\n'|'\r'))* '"'
	;

// escape sequence -- note that this is protected; it can only be called
//   from another lexer rule -- it will not ever directly return a token to
//   the parser
// There are various ambiguities hushed in this rule.  The optional
// '0'...'9' digit matches should be matched here rather than letting
// them go back to STRING_LITERAL to be matched.  ANTLR does the
// right thing by matching immediately; hence, it's ok to shut off
// the FOLLOW ambig warnings.
protected
ESC
	:	'\\'
		(	'n'
		|	'r'
		|	't'
		|	'b'
		|	'f'
		|	'"'
		|	'\''
		|	'\\'
		|	('u')+ HEX_DIGIT HEX_DIGIT HEX_DIGIT HEX_DIGIT
		|	'0'..'3'
			(
				options {
					warnWhenFollowAmbig = false;
				}
			:	'0'..'7'
				(
					options {
						warnWhenFollowAmbig = false;
					}
				:	'0'..'7'
				)?
			)?
		|	'4'..'7'
			(
				options {
					warnWhenFollowAmbig = false;
				}
			:	'0'..'7'
			)?
		)
	;


// hexadecimal digit (again, note it's protected!)
protected
HEX_DIGIT
	:	('0'..'9'|'A'..'F'|'a'..'f')
	;    